package com.hai.config;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.hai.common.exception.ErrorCode;
import com.hai.common.exception.ErrorHelp;
import com.hai.common.exception.SysCode;
import com.hai.common.utils.RedisUtil;
import com.hai.model.MtSmsMessageModel;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import javax.net.ssl.*;
import java.io.*;
import java.net.URL;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
public class HuaWeiSmsService {

    @Resource
    private RedisUtil redisUtil;

    private static String requestUrl = "https://139.9.32.119:18312/common/sms/sendTemplateMessage";
    private static String account = "760887";
    private static String password = "Z.o'&mO%7_?5M,Br";


    public void sendGasPriceInsufficient(String phone,String gasName) {
        try {

            // ip：port根据实际情况填写
            String smsTemplateId = "SMS_22070500005";
            Map<String, String> templateParas = new HashMap<String, String>();
            templateParas.put("name",  gasName);

            // If the request body does not contain the signature name, set signature to null.
            Map<String, Object> body = buildRequestBody(phone, smsTemplateId, templateParas, account, password);
            if (null == body || body.isEmpty()) {
                throw ErrorHelp.genException(SysCode.System, ErrorCode.COMMON_ERROR, "初始化短信请求失败");
            }

            HttpsURLConnection connection = null;
            InputStream is = null;
            BufferedReader br = null;
            trustAllHttpsCertificates();
            try {
                URL realUrl = new URL(requestUrl);
                connection = (HttpsURLConnection) realUrl.openConnection();
                connection.setHostnameVerifier(DO_NOT_VERIFY);
                connection.setDoInput(true); // 设置可输入
                connection.setDoOutput(true); // 设置该连接是可以输出的
                connection.setRequestMethod("POST"); // 设置请求方式
                connection.setRequestProperty("Content-Type", "application/json;charset=UTF-8");
                // connection.connect();
                ObjectMapper objectMapper = new ObjectMapper();
                PrintWriter pw = new PrintWriter(new OutputStreamWriter(connection.getOutputStream(), "UTF-8"));
                pw.write(objectMapper.writeValueAsString(body));
                pw.flush();
                pw.close();

                br = new BufferedReader(new InputStreamReader(connection.getInputStream(), "utf-8"));
                int status = connection.getResponseCode();
                if (200 == status) { // 200
                    is = connection.getInputStream();
                } else { // 400/401
                    is = connection.getErrorStream();
                }
                br = new BufferedReader(new InputStreamReader(is, "UTF-8"));
                String line = null;
                StringBuilder result = new StringBuilder();
                while ((line = br.readLine()) != null) { // 读取数据
                    result.append(line + "");
                }
                connection.disconnect();
            } catch (Exception e) {
                e.printStackTrace();
            } finally {
                try {
                    if (null != is) {
                        is.close();
                    }
                    if (null != br) {
                        br.close();
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        } catch (Exception e) {
            throw ErrorHelp.genException(SysCode.System, ErrorCode.COMMON_ERROR, "短信发送失败");
        }
    }

    /**
     * 设置不验证主机
     */
    private static final HostnameVerifier DO_NOT_VERIFY = new HostnameVerifier() {
        @Override
        public boolean verify(String hostname, SSLSession session) {
            return true;
        }
    };

    // msisdn, smsTemplateId, paramValues, countryID
    public static Map<String, Object> buildRequestBody(String msisdn, String smsTemplateId,
                                                       Map<String, String> paramValues, String accout, String passward) {
        if (null == msisdn || null == smsTemplateId || null == accout || null == passward) {
            System.out.println(
                    "buildRequestBody(): mobiles, templateId or templateParas or account or password is null.");
            return null;
        }


        Map<String, Object> map = new HashMap<String, Object>();
        List<MtSmsMessageModel> requestLists = new ArrayList<MtSmsMessageModel>();
        MtSmsMessageModel mtSmsMessage = new MtSmsMessageModel();
        List<String> mobiles = new ArrayList<String>();
        mobiles.add(msisdn);
        mtSmsMessage.setMobiles(mobiles);
        mtSmsMessage.setTemplateId(smsTemplateId);
        mtSmsMessage.setTemplateParas(paramValues);
        mtSmsMessage.setSignature("【嗨森逛】");
        requestLists.add(mtSmsMessage);
        map.put("account", accout);
        map.put("password", passward);
        map.put("requestLists", requestLists);
        return map;
    }

    static void trustAllHttpsCertificates() throws Exception {
        TrustManager[] trustAllCerts = new TrustManager[] {
                new X509TrustManager() {
                    @Override
                    public void checkClientTrusted(X509Certificate[] chain, String authType) throws CertificateException {
                        return;
                    }

                    @Override
                    public void checkServerTrusted(X509Certificate[] chain, String authType) throws CertificateException {
                        return;
                    }

                    @Override
                    public X509Certificate[] getAcceptedIssuers() {
                        return null;
                    }
                }
        };
        SSLContext sc = SSLContext.getInstance("SSL");
        sc.init(null, trustAllCerts, null);
        HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
    }
}
