package com.hai.dao;

import com.hai.entity.HighDiscountInventoryRecord;
import com.hai.entity.HighDiscountInventoryRecordExample.Criteria;
import com.hai.entity.HighDiscountInventoryRecordExample.Criterion;
import com.hai.entity.HighDiscountInventoryRecordExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighDiscountInventoryRecordSqlProvider {

    public String countByExample(HighDiscountInventoryRecordExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_discount_inventory_record");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighDiscountInventoryRecordExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_discount_inventory_record");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighDiscountInventoryRecord record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_discount_inventory_record");
        
        if (record.getDiscountPackageTitle() != null) {
            sql.VALUES("discount_package_title", "#{discountPackageTitle,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPackageId() != null) {
            sql.VALUES("discount_package_id", "#{discountPackageId,jdbcType=INTEGER}");
        }
        
        if (record.getNowStockNum() != null) {
            sql.VALUES("now_stock_num", "#{nowStockNum,jdbcType=INTEGER}");
        }
        
        if (record.getFrontStockNum() != null) {
            sql.VALUES("front_stock_num", "#{frontStockNum,jdbcType=INTEGER}");
        }
        
        if (record.getStockNum() != null) {
            sql.VALUES("stock_num", "#{stockNum,jdbcType=INTEGER}");
        }
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedUserId() != null) {
            sql.VALUES("created_user_id", "#{createdUserId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedTime() != null) {
            sql.VALUES("created_time", "#{createdTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighDiscountInventoryRecordExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("discount_package_title");
        sql.SELECT("discount_package_id");
        sql.SELECT("now_stock_num");
        sql.SELECT("front_stock_num");
        sql.SELECT("stock_num");
        sql.SELECT("company_id");
        sql.SELECT("created_user_id");
        sql.SELECT("created_time");
        sql.SELECT("`status`");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_discount_inventory_record");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighDiscountInventoryRecord record = (HighDiscountInventoryRecord) parameter.get("record");
        HighDiscountInventoryRecordExample example = (HighDiscountInventoryRecordExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_discount_inventory_record");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountPackageTitle() != null) {
            sql.SET("discount_package_title = #{record.discountPackageTitle,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPackageId() != null) {
            sql.SET("discount_package_id = #{record.discountPackageId,jdbcType=INTEGER}");
        }
        
        if (record.getNowStockNum() != null) {
            sql.SET("now_stock_num = #{record.nowStockNum,jdbcType=INTEGER}");
        }
        
        if (record.getFrontStockNum() != null) {
            sql.SET("front_stock_num = #{record.frontStockNum,jdbcType=INTEGER}");
        }
        
        if (record.getStockNum() != null) {
            sql.SET("stock_num = #{record.stockNum,jdbcType=INTEGER}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedUserId() != null) {
            sql.SET("created_user_id = #{record.createdUserId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedTime() != null) {
            sql.SET("created_time = #{record.createdTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_discount_inventory_record");
        
        sql.SET("id = #{record.id,jdbcType=INTEGER}");
        sql.SET("discount_package_title = #{record.discountPackageTitle,jdbcType=VARCHAR}");
        sql.SET("discount_package_id = #{record.discountPackageId,jdbcType=INTEGER}");
        sql.SET("now_stock_num = #{record.nowStockNum,jdbcType=INTEGER}");
        sql.SET("front_stock_num = #{record.frontStockNum,jdbcType=INTEGER}");
        sql.SET("stock_num = #{record.stockNum,jdbcType=INTEGER}");
        sql.SET("company_id = #{record.companyId,jdbcType=INTEGER}");
        sql.SET("created_user_id = #{record.createdUserId,jdbcType=INTEGER}");
        sql.SET("created_time = #{record.createdTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighDiscountInventoryRecordExample example = (HighDiscountInventoryRecordExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighDiscountInventoryRecord record) {
        SQL sql = new SQL();
        sql.UPDATE("high_discount_inventory_record");
        
        if (record.getDiscountPackageTitle() != null) {
            sql.SET("discount_package_title = #{discountPackageTitle,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPackageId() != null) {
            sql.SET("discount_package_id = #{discountPackageId,jdbcType=INTEGER}");
        }
        
        if (record.getNowStockNum() != null) {
            sql.SET("now_stock_num = #{nowStockNum,jdbcType=INTEGER}");
        }
        
        if (record.getFrontStockNum() != null) {
            sql.SET("front_stock_num = #{frontStockNum,jdbcType=INTEGER}");
        }
        
        if (record.getStockNum() != null) {
            sql.SET("stock_num = #{stockNum,jdbcType=INTEGER}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedUserId() != null) {
            sql.SET("created_user_id = #{createdUserId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedTime() != null) {
            sql.SET("created_time = #{createdTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=INTEGER}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighDiscountInventoryRecordExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}