package com.hai.dao;

import com.hai.entity.HighTySalesman;
import com.hai.entity.HighTySalesmanExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighTySalesmanMapper extends HighTySalesmanMapperExt {
    @SelectProvider(type=HighTySalesmanSqlProvider.class, method="countByExample")
    long countByExample(HighTySalesmanExample example);

    @DeleteProvider(type=HighTySalesmanSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighTySalesmanExample example);

    @Delete({
        "delete from high_ty_salesman",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_ty_salesman (ty_agent_id, salesman_key, ",
        "salesman_name, salesman_phone, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{tyAgentId,jdbcType=BIGINT}, #{salesmanKey,jdbcType=VARCHAR}, ",
        "#{salesmanName,jdbcType=VARCHAR}, #{salesmanPhone,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighTySalesman record);

    @InsertProvider(type=HighTySalesmanSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighTySalesman record);

    @SelectProvider(type=HighTySalesmanSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="ty_agent_id", property="tyAgentId", jdbcType=JdbcType.BIGINT),
        @Result(column="salesman_key", property="salesmanKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="salesman_name", property="salesmanName", jdbcType=JdbcType.VARCHAR),
        @Result(column="salesman_phone", property="salesmanPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighTySalesman> selectByExample(HighTySalesmanExample example);

    @Select({
        "select",
        "id, ty_agent_id, salesman_key, salesman_name, salesman_phone, `status`, create_time, ",
        "update_time, ext_1, ext_2, ext_3",
        "from high_ty_salesman",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="ty_agent_id", property="tyAgentId", jdbcType=JdbcType.BIGINT),
        @Result(column="salesman_key", property="salesmanKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="salesman_name", property="salesmanName", jdbcType=JdbcType.VARCHAR),
        @Result(column="salesman_phone", property="salesmanPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighTySalesman selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighTySalesmanSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighTySalesman record, @Param("example") HighTySalesmanExample example);

    @UpdateProvider(type=HighTySalesmanSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighTySalesman record, @Param("example") HighTySalesmanExample example);

    @UpdateProvider(type=HighTySalesmanSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighTySalesman record);

    @Update({
        "update high_ty_salesman",
        "set ty_agent_id = #{tyAgentId,jdbcType=BIGINT},",
          "salesman_key = #{salesmanKey,jdbcType=VARCHAR},",
          "salesman_name = #{salesmanName,jdbcType=VARCHAR},",
          "salesman_phone = #{salesmanPhone,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighTySalesman record);
}